#!/usr/bin/perl -w

use strict;
use FileHandle;

my $fh = \*STDOUT;

$fh->print( << 'EOF' );
#ifndef _G95X_STRING
#define _G95X_STRING

#define G95X_S_HN "-"

EOF

my @H = qw[
1              1                  
2              2                  
3              3                  
abstract       ABSTRACT           
access         ACCESS             
action         ACTION             
actual         ACTUAL             
advance        ADVANCE            
all            ALL                
allocatable    ALLOCATABLE        
allocate       ALLOCATE           
alloc          ALLOCATION         
alt            ALT                
arg            ARG                
arithmetic     ARITHMETIC         
array          ARRAY              
assign         ASSIGN             
assgt          ASSIGNMENT         
g-S-ref        ASSOCIATION        
asynchronous   ASYNCHRONOUS       
attr           ATTR               
backspace      BACKSPACE          
bind           BIND               
bind(C)        BIND_C_            
blank          BLANK              
block          BLOCK              
body           BODY               
bound          BOUND              
boz            BOZ                
C              C                  
call           CALL               
case           CASE               
char           CHAR               
close          CLOSE              
code           CODE               
common         COMMON             
component      COMPONENT          
cpp            CPP
CST            CONSTANT           
construct      CONSTRUCT          
constructor    CONSTRUCTOR        
continue       CONTINUE           
cnt            CONTROL            
co             CO                 
contains       CONTAINS           
critical       CRITICAL           
cycle          CYCLE              
data           DATA               
deallocate     DEALLOCATE         
decimal        DECIMAL            
decl           DECL               
def            DEF                
defined        DEFINED            
delim          DELIM              
derived        DERIVED            
dimension      DIMENSION          
direct         DIRECT             
do             DO                 
dummy          DUMMY              
element        ELEMENT            
else           ELSE               
end            END                
enddo          ENDDO              
endfile        ENDFILE            
entity         ENTITY             
entry          ENTRY              
enum           ENUM               
enumeration    ENUMERATION        
enumerator     ENUMERATOR         
eor            EOR                
equivalence    EQUIVALENCE        
err            ERROR              
executable     EXECUTABLE         
exist          EXIST              
exit           EXIT               
E              EXPR               
external       EXTERNAL           
file           FILE               
fixed          FIXED              
flavor         FLAVOR             
flush          FLUSH              
forall         FORALL             
fortran        FORTRAN
fmt            FORMAT             
fmt            FMT                
formatted      FORMATTED          
form           FORM               
fct            FUNCTION           
free           FREE               
G              GLOBAL             
generic        GENERIC            
goto           GOTO               
group          GROUP              
hollerith      HOLLERITH          
if             IF                 
implicit       IMPLICIT           
implied        IMPLIED            
import         IMPORT             
include        INCLUDE
included       INCLUDED
init           INITIALIZATION     
input          INPUT              
inquire        INQUIRE            
intent(in)     INTENT_IN_         
intent(out)    INTENT_OUT_        
intent(inout)  INTENT_INOUT_      
internal       INTERNAL           
intf           INTERFACE          
intrinsic      INTRINSIC          
io             IO                 
iolength       IOLENGTH           
iomsg          IOMSG              
iostat         IOSTAT             
item           ITEM               
iterator       ITERATOR           
keyword        KEYWORD            
kind           KIND               
label          LABEL              
length         LENGTH             
letter         LETTER             
line           LINE               
lst            LIST               
l              LOCAL              
location       LOCATION           
locus          LOCUS              
lower          LOWER              
main           MAIN               
mask           MASK               
module         MODULE             
msg            MESSAGE            
named          NAMED              
nml            NAMELIST           
N              NAME               
name           NAME_IO
nextrec        NEXTREC            
none           NONE               
nopass         NOPASS             
null           NULL               
nullify        NULLIFY            
number         NUMBER             
obj            OBJECT             
op             OPERATOR           
op1            OPERAND1           
op2            OPERAND2           
opened         OPENED             
open           OPEN               
optional       OPTIONAL           
output         OUTPUT             
pad            PAD                
parameter      PARAMETER          
part           PART               
pause          PAUSE              
pointer        POINTER            
position       POSITION           
pos            POS                
print          PRINT              
private        PRIVATE            
proc           PROCEDURE          
program        PROGRAM            
protected      PROTECTED          
public         PUBLIC             
read           READ               
readwrite      READWRITE          
recl           RECL               
rec            REC                
ref            REFERENCE          
rename         RENAME             
repeat         REPEAT             
result         RESULT             
return         RETURN             
rewind         REWIND             
save           SAVE               
saved          SAVED              
SC             SECTION            
select         SELECT             
selector       SELECTOR           
sequence       SEQUENCE           
sequential     SEQUENTIAL         
set            SET                
shape          SHAPE              
simple         SIMPLE             
size           SIZE               
spec           SPEC               
specific       SPECIFIC           
start          START              
stat           STAT               
status         STATUS             
step           STEP               
stmt           STATEMENT          
stop           STOP               
stride         STRIDE             
subprogram     SUBPROGRAM         
subr           SUBROUTINE         
SS             SUBSCRIPT          
sync           SYNC               
target         TARGET             
then           THEN               
triplet        TRIPLET            
T              TYPE               
unformatted    UNFORMATTED        
unit           UNIT               
upper          UPPER              
use            USE                
user           USER               
val            VALUE              
var            VARIABLE           
vector         VECTOR             
volatile       VOLATILE           
wait           WAIT               
where          WHERE              
write          WRITE              
recursive      RECURSIVE          
pure           PURE               
elemental      ELEMENTAL          
prefix         PREFIX             
*              STAR               
images         IMAGES             
team           TEAM               
memory         MEMORY             
nameless       NAMELESS           
full           FULL               
substring      SUBSTRING          
literal        LITERAL            
structure      STRUCTURE          
explicit       EXPLICIT           
assumed        ASSUMED            
deferred       DEFERRED           

+       OP_PLUS            
-       OP_MINUS           
*       OP_TIMES           
/       OP_DIVIDE          
**      OP_POWER           
//      OP_CONCAT          
.and.   OP_AND             
.or.    OP_OR              
.eqv.   OP_EQV             
.neqv.  OP_NEQV            
.eq.    OP_EQ              
.ne.    OP_NE              
.gt.    OP_GT              
.ge.    OP_GE              
.lt.    OP_LT              
.le.    OP_LE              
.not.   OP_NOT             
=       OP_ASSIGN          
           
s       SYMBOL_REF         
sg      SYMBOL_GREF        
ct      COMPONENT_REF      
cn      COMMON_REF         
g       GENERIC_REF        
o       OPERATOR_REF       
a       ASSIGNMENT_REF     
           
id      ID                 
S       SYMBOL             


];

my @h = @H;
my ( %hk, %hv );
while( my ( $key, $val ) = splice( @h, 0, 2 ) ) {
  $fh->printf( "#define G95X_S_%-20s \"%s\"\n", $val, $key );
# if( $hk{$key}++ > 0 ) { die( "$key appears twice\n" ); }
  if( $hv{$val}++ > 0 ) { die( "$val appears twice\n" ); }
}

$fh->print( << 'EOF' );

#endif
EOF


__END__

































